using DiscUtils.Iso9660;
using Microsoft.Extensions.Logging;

namespace File_Folder_Helper.Day;

internal static partial class Helper20240107
{

    private static void DirectoryToISO(ILogger<Worker> logger, string destinationDirectory, string directory)
    {
        string relativePath;
        string directoryName = Path.GetFileName(directory);
        CDBuilder builder = new() { UseJoliet = true, VolumeIdentifier = directoryName };
        IEnumerable<string> files = Directory.EnumerateFiles(directory, "*", SearchOption.AllDirectories);
        foreach (string file in files)
        {
            relativePath = Path.GetRelativePath(directory, file);
            _ = builder.AddFile(relativePath, file);
        }
        logger.LogInformation(destinationDirectory);
        builder.Build(Path.Combine(destinationDirectory, $"{directoryName}.iso"));
        logger.LogInformation(directoryName);
    }

    internal static void DirectoryToISO(ILogger<Worker> logger, List<string> args)
    {
        string sourceDirectory = args[0];
        int directories = int.Parse(args[2]);
        string destinationDirectory = args[3];
        logger.LogInformation(sourceDirectory);
        string[] subDirectories = directories == 1 ? [sourceDirectory] : Directory.GetDirectories(sourceDirectory, "*", SearchOption.TopDirectoryOnly);
        if (subDirectories.Length != directories)
            throw new Exception($"{directories} != {subDirectories.Length}");
        foreach (string directory in subDirectories)
            DirectoryToISO(logger, destinationDirectory, directory);
    }

}